import java.awt.*;
import java.awt.image.*;

public class cFastCode extends java.applet.Applet {
	MemoryImageSource mis;
	int [] sbuf;
	int [] buf;
	java.awt.Image img;
	int [] flower;
	double hfase, vfase;	
		
	public void init () {
		sbuf = new int [320*200];
		buf = new int [32*20];
		flower = new int [64*40];
		mis = new MemoryImageSource (320, 200, 
			new DirectColorModel (24, 0xff0000, 0x00ff00, 0x0000ff), sbuf, 0, 320);
		img = this.createImage (mis);
		
		for (int w = 0 ; w < 64 ; w++) {
			for (int h = 0; h < 40 ; h++) {
				double dist0 = Math.sqrt (Math.pow (Math.abs (32-w),2)+Math.pow (Math.abs (20-h),2));
				double stuff0 = Math.sin (Math.atan2 (Math.abs (32-w),Math.abs(20-h))*2);
				double value0 = Math.sin(dist0)*40+stuff0*10;
				double dist1 = Math.sqrt (Math.pow (Math.abs (32-w),2)+Math.pow (Math.abs (20-h),2));
				double stuff1 = Math.sin (Math.atan2 (Math.abs (32-w),Math.abs(20-h))*2);
				double value1 = 255-(Math.sin(dist1)*20+stuff1*20);
				double dist2 = Math.sqrt (Math.pow (Math.abs (32-w),2)+Math.pow (Math.abs (20-h),2));
				double stuff2 = Math.sin (Math.atan2 (Math.abs (32-w),Math.abs(20-h))*2);
				double value2 = (Math.sin(dist2)*20+stuff2*20);
				
				flower [w+h*64] = pack((byte)value0, (byte)value1, (byte)value2);
			}
		}
		
		repaint ();
	}
	
	public void update (Graphics g) {
		paint (g);	
	}

	public void paint (Graphics g) {
		// do stuff here

		doEffect ();		
		
		fillBuf ();
		img.flush ();
		g.drawImage (img, 0, 0, null);
		repaint ();
	}
	
	private void doEffect () {
		hfase += 0.1;
		vfase += 0.16;
//		hfase = (System.currentTimeMillis ()/100);
//		vfase = (System.currentTimeMillis ()/80);
		int hoff0 = (int) (Math.sin (hfase)*10);
		int voff0 = (int) (Math.sin (vfase)*8);
		int hoff1 = (int) (Math.sin (hfase+0.5)*4);
		int voff1 = (int) (Math.sin (vfase+0.1)*6);
		int hoff2 = (int) (Math.sin (hfase+0.3)*14);
		int voff2 = (int) (Math.sin (vfase+0.1)*3);
		for (int w = 0 ; w < 32 ; w++) {
			for (int h = 0; h < 20 ; h++) {
				int pix =  flower [(w+16+hoff0)+(h+10+voff0)*64];
					pix += flower [(w+16+hoff1)+(h+10+voff1)*64];
					pix += flower [(w+16+hoff2)+(h+10+voff2)*64];
				buf [w+h*32] = pix;
			}
		}
	}
	
	private int pack (byte r, byte g, byte b) {
		return r<<16|g<<8|b;
	}
	
	private void fillBuf () {
		for (int w = 0 ; w < 32 ; w++) {
			for (int h = 0; h < 20 ; h++) {
				final int pix = buf [w+h*32];
				sbuf [w*10+0+(h*320)*10+0*320] = pix; 
				sbuf [w*10+0+(h*320)*10+1*320] = pix; 
				sbuf [w*10+0+(h*320)*10+2*320] = pix; 
				sbuf [w*10+0+(h*320)*10+3*320] = pix; 
				sbuf [w*10+0+(h*320)*10+4*320] = pix; 
				sbuf [w*10+0+(h*320)*10+5*320] = pix; 
				sbuf [w*10+0+(h*320)*10+6*320] = pix; 
				sbuf [w*10+0+(h*320)*10+7*320] = pix; 
				sbuf [w*10+0+(h*320)*10+8*320] = pix; 
				sbuf [w*10+0+(h*320)*10+9*320] = pix; 
				sbuf [w*10+1+(h*320)*10+0*320] = pix; 
				sbuf [w*10+1+(h*320)*10+1*320] = pix; 
				sbuf [w*10+1+(h*320)*10+2*320] = pix; 
				sbuf [w*10+1+(h*320)*10+3*320] = pix; 
				sbuf [w*10+1+(h*320)*10+4*320] = pix; 
				sbuf [w*10+1+(h*320)*10+5*320] = pix; 
				sbuf [w*10+1+(h*320)*10+6*320] = pix; 
				sbuf [w*10+1+(h*320)*10+7*320] = pix; 
				sbuf [w*10+1+(h*320)*10+8*320] = pix; 
				sbuf [w*10+1+(h*320)*10+9*320] = pix; 
				sbuf [w*10+2+(h*320)*10+0*320] = pix; 
				sbuf [w*10+2+(h*320)*10+1*320] = pix; 
				sbuf [w*10+2+(h*320)*10+2*320] = pix; 
				sbuf [w*10+2+(h*320)*10+3*320] = pix; 
				sbuf [w*10+2+(h*320)*10+4*320] = pix; 
				sbuf [w*10+2+(h*320)*10+5*320] = pix; 
				sbuf [w*10+2+(h*320)*10+6*320] = pix; 
				sbuf [w*10+2+(h*320)*10+7*320] = pix; 
				sbuf [w*10+2+(h*320)*10+8*320] = pix; 
				sbuf [w*10+2+(h*320)*10+9*320] = pix; 
				sbuf [w*10+3+(h*320)*10+0*320] = pix; 
				sbuf [w*10+3+(h*320)*10+1*320] = pix; 
				sbuf [w*10+3+(h*320)*10+2*320] = pix; 
				sbuf [w*10+3+(h*320)*10+3*320] = pix; 
				sbuf [w*10+3+(h*320)*10+4*320] = pix; 
				sbuf [w*10+3+(h*320)*10+5*320] = pix; 
				sbuf [w*10+3+(h*320)*10+6*320] = pix; 
				sbuf [w*10+3+(h*320)*10+7*320] = pix; 
				sbuf [w*10+3+(h*320)*10+8*320] = pix; 
				sbuf [w*10+3+(h*320)*10+9*320] = pix; 
				sbuf [w*10+4+(h*320)*10+0*320] = pix; 
				sbuf [w*10+4+(h*320)*10+1*320] = pix; 
				sbuf [w*10+4+(h*320)*10+2*320] = pix; 
				sbuf [w*10+4+(h*320)*10+3*320] = pix; 
				sbuf [w*10+4+(h*320)*10+4*320] = pix; 
				sbuf [w*10+4+(h*320)*10+5*320] = pix; 
				sbuf [w*10+4+(h*320)*10+6*320] = pix; 
				sbuf [w*10+4+(h*320)*10+7*320] = pix; 
				sbuf [w*10+4+(h*320)*10+8*320] = pix; 
				sbuf [w*10+4+(h*320)*10+9*320] = pix; 
				sbuf [w*10+5+(h*320)*10+0*320] = pix; 
				sbuf [w*10+5+(h*320)*10+1*320] = pix; 
				sbuf [w*10+5+(h*320)*10+2*320] = pix; 
				sbuf [w*10+5+(h*320)*10+3*320] = pix; 
				sbuf [w*10+5+(h*320)*10+4*320] = pix; 
				sbuf [w*10+5+(h*320)*10+5*320] = pix; 
				sbuf [w*10+5+(h*320)*10+6*320] = pix; 
				sbuf [w*10+5+(h*320)*10+7*320] = pix; 
				sbuf [w*10+5+(h*320)*10+8*320] = pix; 
				sbuf [w*10+5+(h*320)*10+9*320] = pix; 
				sbuf [w*10+6+(h*320)*10+0*320] = pix; 
				sbuf [w*10+6+(h*320)*10+1*320] = pix; 
				sbuf [w*10+6+(h*320)*10+2*320] = pix; 
				sbuf [w*10+6+(h*320)*10+3*320] = pix; 
				sbuf [w*10+6+(h*320)*10+4*320] = pix; 
				sbuf [w*10+6+(h*320)*10+5*320] = pix; 
				sbuf [w*10+6+(h*320)*10+6*320] = pix; 
				sbuf [w*10+6+(h*320)*10+7*320] = pix; 
				sbuf [w*10+6+(h*320)*10+8*320] = pix; 
				sbuf [w*10+6+(h*320)*10+9*320] = pix; 
				sbuf [w*10+7+(h*320)*10+0*320] = pix; 
				sbuf [w*10+7+(h*320)*10+1*320] = pix; 
				sbuf [w*10+7+(h*320)*10+2*320] = pix; 
				sbuf [w*10+7+(h*320)*10+3*320] = pix; 
				sbuf [w*10+7+(h*320)*10+4*320] = pix; 
				sbuf [w*10+7+(h*320)*10+5*320] = pix; 
				sbuf [w*10+7+(h*320)*10+6*320] = pix; 
				sbuf [w*10+7+(h*320)*10+7*320] = pix; 
				sbuf [w*10+7+(h*320)*10+8*320] = pix; 
				sbuf [w*10+7+(h*320)*10+9*320] = pix; 
				sbuf [w*10+8+(h*320)*10+0*320] = pix; 
				sbuf [w*10+8+(h*320)*10+1*320] = pix; 
				sbuf [w*10+8+(h*320)*10+2*320] = pix; 
				sbuf [w*10+8+(h*320)*10+3*320] = pix; 
				sbuf [w*10+8+(h*320)*10+4*320] = pix; 
				sbuf [w*10+8+(h*320)*10+5*320] = pix; 
				sbuf [w*10+8+(h*320)*10+6*320] = pix; 
				sbuf [w*10+8+(h*320)*10+7*320] = pix; 
				sbuf [w*10+8+(h*320)*10+8*320] = pix; 
				sbuf [w*10+8+(h*320)*10+9*320] = pix; 
				sbuf [w*10+9+(h*320)*10+0*320] = pix; 
				sbuf [w*10+9+(h*320)*10+1*320] = pix; 
				sbuf [w*10+9+(h*320)*10+2*320] = pix; 
				sbuf [w*10+9+(h*320)*10+3*320] = pix; 
				sbuf [w*10+9+(h*320)*10+4*320] = pix; 
				sbuf [w*10+9+(h*320)*10+5*320] = pix; 
				sbuf [w*10+9+(h*320)*10+6*320] = pix; 
				sbuf [w*10+9+(h*320)*10+7*320] = pix; 
				sbuf [w*10+9+(h*320)*10+8*320] = pix; 
				sbuf [w*10+9+(h*320)*10+9*320] = pix;
			}
		}
	}
}